#include "../globals.h"
//#include "EnvelopeParams.h"
//#include "LFOParams.h"
//#include "FilterParams.h"


//marimea unei forme de unda (la oscil) - putere al lui 2 !!!!
#define OSCIL_SIZE 512

  enum ONOFFTYPE{OFF,ON};
  enum FMTYPE{NONE,FREQ_MOD,RING_MOD};
    
   /*****************************************************************/
   /*                    PARAMETRII GLOBALI                         */
   /*****************************************************************/

    struct ADnoteGlobalParam{
       /******************************************
	*     PARAMETRII GLOBALI DE FRECVENTA    *
	******************************************/
	unsigned short int PDetune;
	REALTYPE Detune;

	EnvelopeParams *FreqEnvelope; //"Envelop-ul" frecventei (global)
    
	LFOParams *FreqLfo;//LFO-ul global al frecventei

       /********************************************
	*     PARAMETRII GLOBALI DE AMPLITUDINE    *
	********************************************/
	char PVolume;
	REALTYPE Volume;// [ 0 .. 1 ]


	char PAmpVelocityScaleFunction;
	REALTYPE AmpVelocityScaleFunction;//[ -1 .. 1 ]

	EnvelopeParams *AmpEnvelope;
   
	LFOParams *AmpLfo;   

       /******************************************
	*     PARAMETRII GLOBALI DE FILTRU       *
	******************************************/
	FilterParams *GlobalFilter;

	//parametru care depinde de "velocity"
	char PFilterVelocityScale; 
	REALTYPE FilterVelocityScale; //cate octave

	//parametru care depinde de "velocity"
	char PFilterVelocityScaleFunction;
	REALTYPE FilterVelocityScaleFunction;//[ -1 .. 1 ]
    
	EnvelopeParams *FilterEnvelope;
    
	LFOParams *FilterLfo;
    };  


    
   /***********************************************************************/
   /*                    PARAMETRII FIECAREI VOCI                         */
   /***********************************************************************/
    struct ADnoteVoiceParam{
        /*Daca este activata Vocea*/
        ONOFFTYPE Enabled; 
  
        /*Forma de unda al oscilatorului din Voce*/ 
        REALTYPE *OscilSmp;    

        /**********************************
	*     PARAMETRII DE FRECVENTA    *
	**********************************/

	/*Reglajul 'fin' a frecventei vocii*/
	unsigned short int  PDetune;
	REALTYPE Detune;//(se masoara in centi)frecventa de baza a fiecarui oscilator = basefreq*VoiceDetune
    
	/*Envelop-ul frecventei pt. fiecare voce (glissando)*/
	char PFreqEnvelopeEnabled;
	EnvelopeParams *FreqEnvelope;

	/*LFO-ul frecventei pentru fiecare voce (vibratto)*/
	char PFreqLfoEnabled;
	LFOParams *FreqLfo;
    

	/*********************************
	*   PARAMETRII DE AMPLITUDINE   *
	*********************************/

	/*Volumul vocii*/          
	char PVolume;
	REALTYPE Volume;

	/* Functia de transformare al velocity-ului*/
	char PAmpVelocityScaleFunction;
	REALTYPE AmpVelocityScaleFunction;//[ -1 .. 1 ]

	/*Envelop-ul amplitudinii pt. fiecare voce (ADSR)*/
	char PAmpEnvelopeEnabled;
	EnvelopeParams *AmpEnvelope;
    
	/*LFO-ul amplitudinii pt. fiecare voce (termollo)*/
	char PAmpLfoEnabled;
	LFOParams *AmpLfo;



	/****************************
	*   PARAMETRII DE FILTRU   *
	****************************/
    
	/*Filtrul pentru fiecare voce*/
	char PFilterEnabled;
	FilterParams *VoiceFilter;
    
	/*Envelope-ul filtrului pentru fiecare voce*/
	char PFilterEnvelopeEnabled;
	EnvelopeParams *FilterEnvelope;
    
	/*LFO-ul filtrului pentru fiecare voce*/
	char PFilterLfoEnabled;
	LFOParams *FilterLfo;

	/********************************
	*   PARAMETRII DE FM/RingMod   *
	********************************/

	/*Daca este activata FM-ul sau RingModulation*/
	char PFMEnabled;
	FMTYPE FMEnabled;

	/*Forma de unda al oscilatorului din Voce*/
	REALTYPE *FMSmp;    

	/*Volumul (intensitatea) FM-ului/RM*/
	char PFMVolume;
	REALTYPE FMVolume;

	/* Functia de transformare al velocity-ului*/
	char PFMVelocityScaleFunction;
	REALTYPE FMVelocityScaleFunction;//[ -1 .. 1 ]

	/*Acordul fin al FM-ului/RM*/
	unsigned short int PFMDetune; 
	REALTYPE FMDetune; //in centi
    
	/*Envelope-ul FRECVENTEI FM-ului/RM  pentru fiecare voce*/
	char PFMFreqEnvelopeEnabled;
	EnvelopeParams *FMFreqEnvelope;

	/*Envelope-ul Amplitudinii FM-ului/RM  pentru fiecare voce*/
	char PFMAmpEnvelopeEnabled;
	EnvelopeParams *FMAmpEnvelope;
    }; 

class ADnoteParameters{
    public:
	ADnoteParameters();
	~ADnoteParameters();

	ADnoteGlobalParam GlobalPar;
	ADnoteVoiceParam VoicePar[NUM_VOICES];

    private:
	void EnableVoice(int nvoice);		
        REALTYPE getdetune(unsigned short int midipar);
	void midi2real();//converteste parametrii din char in REALTYPE
	
};
