#include <stdio.h>

#include <math.h>
#include <stdlib.h>
#include "EnvelopeParams.h"

EnvelopeParams::EnvelopeParams(){
    int i;
    for (i=0;i<MAX_ENVELOPE_POINTS;i++){
	Penvdt[i]=32;
	Penvval[i]=64;
    };
    Penvdt[0]=0;//neutilizat
    Penvsustain=1;
    Penvpoints=1;
    Changed=1;//s-a modificat ceva
};

EnvelopeParams::~EnvelopeParams(){
};

void EnvelopeParams::ADSRinit(char A_dt,char D_dt,char S_val,char R_dt){
    Penvpoints=4;
    Penvsustain=2;
    
    Penvval[0]=0;
    Penvdt[1]=A_dt;        
    Penvval[1]=127;
    Penvdt[2]=D_dt;        
    Penvval[2]=S_val;
    Penvdt[3]=R_dt;
    Penvval[3]=0;    
    
    Changed=1;
    midi2real();
};

void EnvelopeParams::ADSRinit_dB(char A_dt,char D_dt,char S_val,char R_dt){
    Penvpoints=4;
    Penvsustain=2;
    
    Penvval[0]=0;
    Penvdt[1]=A_dt;        
    Penvval[1]=127;
    Penvdt[2]=D_dt;        
    Penvval[2]=S_val;
    Penvdt[3]=R_dt;
    Penvval[3]=0;    

    Changed=2;
    
    midi2real();
};

void EnvelopeParams::ASRinit(char A_val,char A_dt,char R_val,char R_dt){
    Penvpoints=3;
    Penvsustain=1;
    
    Penvval[0]=A_val;
    Penvdt[1]=A_dt;
    Penvval[1]=64;//adica 0
    Penvdt[2]=R_dt;
    Penvval[2]=R_val;
    
    Changed=3;
    midi2real();
};

void EnvelopeParams::ADSRinit_filter(char A_val,char A_dt,char D_val,char D_dt,char R_dt,char R_val){
    Penvpoints=4;
    Penvsustain=2;
    
    Penvval[0]=A_val;
    Penvdt[1]=A_dt;
    Penvval[1]=D_val;
    Penvdt[2]=D_dt;
    Penvval[2]=64;//adica 0
    Penvdt[3]=R_dt;
    Penvval[3]=R_val;
        
    Changed=4;
    midi2real();
};


void EnvelopeParams::midi2real(){
    int i;

    if (Changed!=0) {
	for (i=0;i<MAX_ENVELOPE_POINTS;i++) {//for safety
		if (Penvdt[i]<0) Penvdt[i]=0;
		if (Penvval[i]<0) Penvval[i]=0;
		};
	for (i=0;i<MAX_ENVELOPE_POINTS;i++) envdt[i]=(exp((REALTYPE) Penvdt[i]/127.0*LOG_2*12.0)-1)*10.0;
	};

    envdt[0]=0.0;

    switch (Changed){
	case 1: for (i=0;i<MAX_ENVELOPE_POINTS;i++) envval[i]=(REALTYPE) Penvval[i]/127.0;
		break;
	case 2: for (i=0;i<MAX_ENVELOPE_POINTS;i++) envval[i]=(1-(REALTYPE) Penvval[i]/127.0)*MIN_ENVELOPE_DB;
		break;
	case 3: for (i=0;i<MAX_ENVELOPE_POINTS;i++) {
		    envval[i]=(exp(fabs((REALTYPE) Penvval[i]-64.0)/127.0*LOG_2*16.0)-1.0)/10.0;  
		    if (Penvval[i]<64) envval[i]=-envval[i];
		    };
		break;
	case 4: for (i=0;i<MAX_ENVELOPE_POINTS;i++) envval[i]=((REALTYPE) (Penvval[i]-64)/64.0)*6.0;
		break;
    };    
    


/* debug    for (i=0;i<MAX_ENVELOPE_POINTS;i++) {
	if (Changed==1) fprintf(stderr,"%.4f %.4f \n",envdt[i],envval[i]);
    };
    if (Changed==1) fprintf(stderr,"\n\n");
*/
};





