#include <math.h>
#include <stdlib.h>
#include <stdio.h>


#include "ADnote.h"
#include "../globals.h"


ADnote::ADnote(ADnoteParameters *pars,int note,REALTYPE velocity){
  int i,nvoice;
    partparams=*pars;
    
    if (velocity<0.0) velocity=0.0;
	else if (velocity>1.0) velocity=1.0; //just be safe in case of bogus velocity

    NoteEnabled=ON;
    ADnote::note=note;  
    ADnote::velocity=velocity;  
    time=0.0;

    NoteGlobalPar.Detune=pars->GlobalPar.Detune;
    
    NoteGlobalPar.Volume=pars->GlobalPar.Volume;
    NoteGlobalPar.AmpVelocityScaleFunction=pars->GlobalPar.AmpVelocityScaleFunction;

    NoteGlobalPar.FilterCenterPitch=pars->GlobalPar.GlobalFilter->freq;
    NoteGlobalPar.FilterVelocityScale=pars->GlobalPar.FilterVelocityScale;
    NoteGlobalPar.FilterVelocityScaleFunction=pars->GlobalPar.FilterVelocityScaleFunction;
    
        
    for (nvoice=0;nvoice<NUM_VOICES;nvoice++){
	if (pars->VoicePar[nvoice].Enabled==OFF) continue;

	NoteVoicePar[nvoice].Enabled=ON;
	
        oscposhi[nvoice]=0;oscposlo[nvoice]=0.0;
        oscposhiFM[nvoice]=0;oscposloFM[nvoice]=0.0;
	
	NoteVoicePar[nvoice].OscilSmp=new REALTYPE[OSCIL_SIZE];
	for (i=0;i<OSCIL_SIZE;i++) NoteVoicePar[nvoice].OscilSmp[i]=pars->VoicePar[nvoice].OscilSmp[i];
	
    	NoteVoicePar[nvoice].Detune=pars->VoicePar[nvoice].Detune;

	if (pars->VoicePar[nvoice].PFreqLfoEnabled!=0) NoteVoicePar[nvoice].FreqLfoEnabled=ON;
		else NoteVoicePar[nvoice].FreqLfoEnabled=OFF;

	if (pars->VoicePar[nvoice].PFreqEnvelopeEnabled!=0) NoteVoicePar[nvoice].FreqEnvelopeEnabled=ON;
		else NoteVoicePar[nvoice].FreqEnvelopeEnabled=OFF;

	NoteVoicePar[nvoice].Volume=pars->VoicePar[nvoice].Volume;

	if (pars->VoicePar[nvoice].PAmpLfoEnabled!=0) NoteVoicePar[nvoice].AmpLfoEnabled=ON;
		else NoteVoicePar[nvoice].AmpLfoEnabled=OFF;

	if (pars->VoicePar[nvoice].PAmpEnvelopeEnabled!=0) NoteVoicePar[nvoice].AmpEnvelopeEnabled=ON;
		else NoteVoicePar[nvoice].AmpEnvelopeEnabled=OFF;

	NoteVoicePar[nvoice].AmpVelocityScaleFunction=pars->VoicePar[nvoice].AmpVelocityScaleFunction;

	if (pars->VoicePar[nvoice].PFilterEnabled!=0) NoteVoicePar[nvoice].FilterEnabled=ON;
		else NoteVoicePar[nvoice].FilterEnabled=OFF;

	if (pars->VoicePar[nvoice].PFilterEnvelopeEnabled!=0) NoteVoicePar[nvoice].FilterEnvelopeEnabled=ON;
		else NoteVoicePar[nvoice].FilterEnvelopeEnabled=OFF;

	if (pars->VoicePar[nvoice].PFilterLfoEnabled!=0) NoteVoicePar[nvoice].FilterLfoEnabled=ON;
		else NoteVoicePar[nvoice].FilterLfoEnabled=OFF;

	NoteVoicePar[nvoice].FilterCenterPitch=pars->VoicePar[nvoice].VoiceFilter->freq;
	
	
	NoteVoicePar[nvoice].FMEnabled=pars->VoicePar[nvoice].FMEnabled;

	if (pars->VoicePar[nvoice].PFMFreqEnvelopeEnabled!=0) NoteVoicePar[nvoice].FMFreqEnvelopeEnabled=ON;
		else NoteVoicePar[nvoice].FMFreqEnvelopeEnabled=OFF;

	if (pars->VoicePar[nvoice].PFMAmpEnvelopeEnabled!=0) NoteVoicePar[nvoice].FMAmpEnvelopeEnabled=ON;
		else NoteVoicePar[nvoice].FMAmpEnvelopeEnabled=OFF;

	NoteVoicePar[nvoice].FMVolume=pars->VoicePar[nvoice].FMVolume;
	NoteVoicePar[nvoice].FMDetune=pars->VoicePar[nvoice].FMDetune;
	NoteVoicePar[nvoice].FMVelocityScaleFunction=pars->VoicePar[nvoice].FMVelocityScaleFunction;
        oscposhi[nvoice]=rand() % OSCIL_SIZE;//!!!!!!!!!!!!!test

    
  };

    ADnote::initparameters();
};


void ADnote::KillVoice(int nvoice){
    
    delete (NoteVoicePar[nvoice].OscilSmp);

    if (NoteVoicePar[nvoice].AmpEnvelopeEnabled==ON) delete (NoteVoicePar[nvoice].AmpEnvelope);
    NoteVoicePar[nvoice].AmpEnvelopeEnabled=OFF;

    if (NoteVoicePar[nvoice].FreqEnvelopeEnabled==ON) delete(NoteVoicePar[nvoice].FreqEnvelope);
    NoteVoicePar[nvoice].FreqEnvelopeEnabled=OFF;
    
    if (NoteVoicePar[nvoice].FreqLfoEnabled==ON) delete(NoteVoicePar[nvoice].FreqLfo);
    NoteVoicePar[nvoice].FreqLfoEnabled=OFF;
    
    if (NoteVoicePar[nvoice].FilterEnabled==ON) delete (NoteVoicePar[nvoice].VoiceFilter);
    NoteVoicePar[nvoice].FilterEnabled=OFF;

    if (NoteVoicePar[nvoice].FilterEnvelopeEnabled==ON) delete (NoteVoicePar[nvoice].FilterEnvelope);
    NoteVoicePar[nvoice].FilterEnvelopeEnabled=OFF;

    if (NoteVoicePar[nvoice].FilterLfoEnabled==ON) delete (NoteVoicePar[nvoice].FilterLfo);
    NoteVoicePar[nvoice].FilterLfoEnabled=OFF;
    
    if (NoteVoicePar[nvoice].AmpLfoEnabled==ON) delete (NoteVoicePar[nvoice].AmpLfo);
    NoteVoicePar[nvoice].AmpLfoEnabled=OFF;

    if (NoteVoicePar[nvoice].FMFreqEnvelopeEnabled==ON) delete (NoteVoicePar[nvoice].FMFreqEnvelope);
    NoteVoicePar[nvoice].FMFreqEnvelopeEnabled=OFF;
    
    if (NoteVoicePar[nvoice].FMAmpEnvelopeEnabled==ON) delete (NoteVoicePar[nvoice].FMAmpEnvelope);
    NoteVoicePar[nvoice].FMAmpEnvelopeEnabled=OFF;
    
    if (NoteVoicePar[nvoice].FMEnabled!=NONE) delete NoteVoicePar[nvoice].FMSmp;
    
    NoteVoicePar[nvoice].Enabled=OFF;
//    fprintf(stderr,"Killed voice %d \n",nvoice);
    //sa sterg si voice*smp
};

void ADnote::KillNote(){
    int nvoice;
    for (nvoice=0;nvoice<NUM_VOICES;nvoice++){
	if (NoteVoicePar[nvoice].Enabled==ON) KillVoice(nvoice);
    };
    
    delete (NoteGlobalPar.FreqEnvelope);
    delete (NoteGlobalPar.FreqLfo);
    delete (NoteGlobalPar.AmpEnvelope);
    delete (NoteGlobalPar.AmpLfo);
    delete (NoteGlobalPar.GlobalFilter);
    delete (NoteGlobalPar.FilterEnvelope);
    delete (NoteGlobalPar.FilterLfo);
    
    NoteEnabled=OFF;
};

ADnote::~ADnote(){
    if (NoteEnabled==ON) KillNote();
};


REALTYPE ADnote::VelF(REALTYPE scaling){
    scaling=pow(VELOCITY_MAX_SCALE,-scaling);
    return(pow(velocity,scaling));
};


void ADnote::initparameters(){//cand trece de la parametrii la RT
    int nvoice,i;
    
    //Initiez parametrii globali
    NoteGlobalPar.FreqEnvelope=new Envelope(partparams.GlobalPar.FreqEnvelope);    
    
    NoteGlobalPar.FreqLfo=new LFO(partparams.GlobalPar.FreqLfo);
    
    NoteGlobalPar.AmpEnvelope=new Envelope(partparams.GlobalPar.AmpEnvelope);
    NoteGlobalPar.AmpLfo=new LFO(partparams.GlobalPar.AmpLfo);
    globalnewamplitude=NoteGlobalPar.Volume*NoteGlobalPar.AmpEnvelope->envout()*NoteGlobalPar.AmpLfo->amplfoout();

    NoteGlobalPar.GlobalFilter=new Filter(partparams.GlobalPar.GlobalFilter);
    NoteGlobalPar.FilterEnvelope=new Envelope(partparams.GlobalPar.FilterEnvelope);
    NoteGlobalPar.FilterLfo=new LFO(partparams.GlobalPar.FilterLfo);
    NoteGlobalPar.Volume*=VelF(NoteGlobalPar.AmpVelocityScaleFunction);
    NoteGlobalPar.FilterCenterPitch+=NoteGlobalPar.FilterVelocityScale*(VelF(NoteGlobalPar.FilterVelocityScaleFunction)-1);
    
    //Initiez parametrii pentru fiecare voce
    for (nvoice=0;nvoice<NUM_VOICES;nvoice++){
	NoteVoicePar[nvoice].Volume*=VelF(NoteVoicePar[nvoice].AmpVelocityScaleFunction);
	newamplitude[nvoice]=NoteVoicePar[nvoice].Volume;FMnewamplitude[nvoice]=0.0;
	if (NoteVoicePar[nvoice].AmpEnvelopeEnabled==ON) {
		NoteVoicePar[nvoice].AmpEnvelope=new Envelope(partparams.VoicePar[nvoice].AmpEnvelope);
		newamplitude[nvoice]*=NoteVoicePar[nvoice].AmpEnvelope->envout();
	    }else newamplitude[nvoice]=1.0;
	if (NoteVoicePar[nvoice].FreqEnvelopeEnabled==ON) {
		NoteVoicePar[nvoice].FreqEnvelope=new Envelope(partparams.VoicePar[nvoice].FreqEnvelope);
	    };
	if (NoteVoicePar[nvoice].FreqLfoEnabled==ON){
	    NoteVoicePar[nvoice].FreqLfo=new LFO(partparams.VoicePar[nvoice].FreqLfo);
	};
	if (NoteVoicePar[nvoice].FilterEnabled==ON){
	    NoteVoicePar[nvoice].VoiceFilter=new Filter(partparams.VoicePar[nvoice].VoiceFilter);
	};

	if (NoteVoicePar[nvoice].FilterEnvelopeEnabled==ON){
		NoteVoicePar[nvoice].FilterEnvelope=new Envelope(partparams.VoicePar[nvoice].FilterEnvelope);
	};
	if (NoteVoicePar[nvoice].FilterLfoEnabled==ON){
		NoteVoicePar[nvoice].FilterLfo=new LFO(partparams.VoicePar[nvoice].FilterLfo);
	};
	
	if (NoteVoicePar[nvoice].AmpLfoEnabled==ON){
		NoteVoicePar[nvoice].AmpLfo=new LFO(partparams.VoicePar[nvoice].AmpLfo);
		newamplitude[nvoice]*=NoteVoicePar[nvoice].AmpLfo->amplfoout();
	};

	if (NoteVoicePar[nvoice].FMEnabled!=NONE){
	    NoteVoicePar[nvoice].FMSmp=new REALTYPE[OSCIL_SIZE];
	    for (i=0;i<OSCIL_SIZE;i++) NoteVoicePar[nvoice].FMSmp[i]=partparams.VoicePar[nvoice].FMSmp[i];
	};
	if (NoteVoicePar[nvoice].FMFreqEnvelopeEnabled==ON){
		NoteVoicePar[nvoice].FMFreqEnvelope=new Envelope(partparams.VoicePar[nvoice].FMFreqEnvelope);
	};
	if (NoteVoicePar[nvoice].FMAmpEnvelopeEnabled==ON){
		NoteVoicePar[nvoice].FMAmpEnvelope=new Envelope(partparams.VoicePar[nvoice].FMAmpEnvelope);
	};

	NoteVoicePar[nvoice].FMVolume*=VelF(NoteVoicePar[nvoice].FMVelocityScaleFunction);
    };
};



void ADnote::setfreq(int nvoice,REALTYPE freq){
    REALTYPE speed;
    freq=fabs(freq);
    speed=freq*REALTYPE(OSCIL_SIZE)/(REALTYPE) SAMPLE_RATE;
    oscfreqhi[nvoice]=(unsigned short int) floor(speed);
    oscfreqlo[nvoice]=speed-floor(speed);
};   

void ADnote::setfreqFM(int nvoice,REALTYPE freq){
    REALTYPE speed;
    freq=fabs(freq);
    speed=freq*REALTYPE(OSCIL_SIZE)/(REALTYPE) SAMPLE_RATE;
    oscfreqhiFM[nvoice]=(unsigned short int) floor(speed);
    oscfreqloFM[nvoice]=speed-floor(speed);
};


void ADnote::computecurrentparameters(){
    int nvoice;
    REALTYPE voicefreq,voicepitch,filterpitch,filterfreq,FMfreq,FMrelativepitch,globalpitch,globalfilterpitch;
    
    globalpitch=NoteGlobalPar.FreqEnvelope->envout()+NoteGlobalPar.FreqLfo->lfoout()/100;
    
    globaloldamplitude=globalnewamplitude;
    globalnewamplitude=NoteGlobalPar.Volume*NoteGlobalPar.AmpEnvelope->envout_dB()*NoteGlobalPar.AmpLfo->amplfoout();	    /////
    
    globalfilterpitch=NoteGlobalPar.FilterEnvelope->envout()+NoteGlobalPar.FilterLfo->lfoout()+NoteGlobalPar.FilterCenterPitch;
    NoteGlobalPar.GlobalFilter->setfreq(exp(LOG_2*globalfilterpitch)*1000);
    
    for (nvoice=0;nvoice<NUM_VOICES;nvoice++){
	if (NoteVoicePar[nvoice].Enabled!=ON) continue;
	/******************************/
	/* Calculeaza Frecventa vocii */
	/******************************/

	voicepitch=globalpitch+note-57.0+NoteVoicePar[nvoice].Detune/100.0+NoteGlobalPar.Detune/100.0; // semitoni
	if (NoteVoicePar[nvoice].FreqLfoEnabled==ON) voicepitch+=NoteVoicePar[nvoice].FreqLfo->lfoout()/100.0;
	if (NoteVoicePar[nvoice].FreqEnvelopeEnabled==ON) voicepitch+=NoteVoicePar[nvoice].FreqEnvelope->envout();
	voicefreq=exp(LOG_2*voicepitch/12.0)*440;//frecventa in Hz
	setfreq(nvoice,voicefreq);	

	/*********************************/
	/* Calculeaza Amplitudinea vocii */
	/*********************************/
        oldamplitude[nvoice]=newamplitude[nvoice];
	newamplitude[nvoice]=NoteVoicePar[nvoice].Volume;

	if (NoteVoicePar[nvoice].AmpEnvelopeEnabled==ON) {
	    newamplitude[nvoice]*=NoteVoicePar[nvoice].AmpEnvelope->envout_dB();	    
	    };
	    
	if (NoteVoicePar[nvoice].AmpLfoEnabled==ON) {
   	     newamplitude[nvoice]*=NoteVoicePar[nvoice].AmpLfo->amplfoout();	    
	    };

	/****************************/
	/* Calculeaza Filtrul vocii */
	/****************************/
	if (NoteVoicePar[nvoice].FilterEnabled==ON){
	    filterpitch=NoteVoicePar[nvoice].FilterCenterPitch;  
	    if (NoteVoicePar[nvoice].FilterEnvelopeEnabled==ON) {
		    filterpitch+=NoteVoicePar[nvoice].FilterEnvelope->envout();
		};
	    if (NoteVoicePar[nvoice].FilterLfoEnabled==ON) {
		    filterpitch+=NoteVoicePar[nvoice].FilterLfo->lfoout();
		};
	    filterfreq=exp(LOG_2*filterpitch)*1000;
	    NoteVoicePar[nvoice].VoiceFilter->setfreq(filterfreq);
	};

	/************************************/
	/* Calculeaza Parametrii FM/RINGMOD */
	/************************************/
	if (NoteVoicePar[nvoice].FMEnabled!=NONE){
	    FMrelativepitch=NoteVoicePar[nvoice].FMDetune/100.0;
	    if (NoteVoicePar[nvoice].FMFreqEnvelopeEnabled==ON) FMrelativepitch+=NoteVoicePar[nvoice].FMFreqEnvelope->envout();
    	    FMfreq=exp(LOG_2*FMrelativepitch/12.0)*voicefreq;
	    setfreqFM(nvoice,FMfreq);

	    FMoldamplitude[nvoice]=FMnewamplitude[nvoice];
	    FMnewamplitude[nvoice]=NoteVoicePar[nvoice].FMVolume;
	    if (NoteVoicePar[nvoice].FMAmpEnvelopeEnabled==ON) FMnewamplitude[nvoice]*=NoteVoicePar[nvoice].FMAmpEnvelope->envout();
	    };

	
    };
    time+=(REALTYPE)SOUND_BUFFER_SIZE/(REALTYPE)SAMPLE_RATE;
    
};

/*Calculeaza Oscilatorul FARA MODULATIE*/
inline void ADnote::ComputeVoiceOscillator(int nvoice){    
    unsigned short int oscposhi2;
    int i;

    for (i=0;i<SOUND_BUFFER_SIZE;i++){
	//ar fi mai bine ca sa fac array-ul de marimea OSCIL_SIZE+1 si sa pun ultimul emement=primul, si astfel sa scriu in loc oscilposhi2, oscilpos
	oscposhi2=oscposhi[nvoice]+1; if (oscposhi2>=OSCIL_SIZE) oscposhi2-=OSCIL_SIZE;
	tmpwave[i]=NoteVoicePar[nvoice].OscilSmp[oscposhi[nvoice]]*(1-oscposlo[nvoice])+NoteVoicePar[nvoice].OscilSmp[oscposhi2]*oscposlo[nvoice];
	oscposlo[nvoice]+=oscfreqlo[nvoice];
	if (oscposlo[nvoice]>=1.0) {
    		oscposlo[nvoice]-=1.0;	
		oscposhi[nvoice]++;
	};
    	oscposhi[nvoice]+=oscfreqhi[nvoice];    
	if (oscposhi[nvoice]>=OSCIL_SIZE) oscposhi[nvoice]-=OSCIL_SIZE;
    };
};

/*Calculeaza Oscilatorul cu RING MODULATION*/
inline void ADnote::ComputeVoiceOscillatorRingModulation(int nvoice){    
    unsigned short int oscposhi2;
    int i;
    ComputeVoiceOscillator(nvoice);    
    if (FMnewamplitude[nvoice]>1.0) FMnewamplitude[nvoice] =1.0;
    if (FMoldamplitude[nvoice]>1.0) FMoldamplitude[nvoice] =1.0;
    for (i=0;i<SOUND_BUFFER_SIZE;i++){
	oscposhi2=oscposhiFM[nvoice]+1; if (oscposhi2>=OSCIL_SIZE) oscposhi2-=OSCIL_SIZE;
	tmpwave[i]*=(NoteVoicePar[nvoice].FMSmp[oscposhiFM[nvoice]]*(1-oscposloFM[nvoice])+NoteVoicePar[nvoice].FMSmp[oscposhi2]*oscposloFM[nvoice])*FMnewamplitude[nvoice]+(1-FMnewamplitude[nvoice]);
	oscposloFM[nvoice]+=oscfreqloFM[nvoice];
	if (oscposloFM[nvoice]>=1.0) {
    		oscposloFM[nvoice]-=1.0;	
		oscposhiFM[nvoice]++;
	};
    	oscposhiFM[nvoice]+=oscfreqhiFM[nvoice];    
	if (oscposhiFM[nvoice]>=OSCIL_SIZE) oscposhiFM[nvoice]-=OSCIL_SIZE;
    };
};

/*Calculeaza Oscilatorul cu FREQUENCY MODULATION*/
inline void ADnote::ComputeVoiceOscillatorFM(int nvoice){    
    int oscposhi2,carposhi;
    int i,FMmodfreqhi;
    REALTYPE FMmodfreqlo,carposlo;
    
    for (i=0;i<SOUND_BUFFER_SIZE;i++){
	//calculez modulatorul si il pun in tmpwave[]
	oscposhi2=oscposhiFM[nvoice]+1; if (oscposhi2>=OSCIL_SIZE) oscposhi2-=OSCIL_SIZE;
	tmpwave[i]=(NoteVoicePar[nvoice].FMSmp[oscposhiFM[nvoice]]*(1-oscposloFM[nvoice])+NoteVoicePar[nvoice].FMSmp[oscposhi2]*oscposloFM[nvoice]);
	oscposloFM[nvoice]+=oscfreqloFM[nvoice];
	if (oscposloFM[nvoice]>=1.0) {
    		oscposloFM[nvoice]-=1.0;	
		oscposhiFM[nvoice]++;
	};
    	oscposhiFM[nvoice]+=oscfreqhiFM[nvoice];    
	if (oscposhiFM[nvoice]>=OSCIL_SIZE) oscposhiFM[nvoice]-=OSCIL_SIZE;
	};

    //interpoleaza amplitudinea FM-ului
    if (2.0*fabs(FMnewamplitude[nvoice]-FMoldamplitude[nvoice])/(FMnewamplitude[nvoice]+FMoldamplitude[nvoice]+0.00000001)>AMPLITUDE_INTERPOLATION_THRESHOLD){
          for (i=0;i<SOUND_BUFFER_SIZE;i++){
		tmpwave[i]*=(FMoldamplitude[nvoice]+(FMnewamplitude[nvoice]-FMoldamplitude[nvoice])*(REALTYPE)i/(REALTYPE)SOUND_BUFFER_SIZE)/(REALTYPE)OSCIL_SIZE*FM_AMP_MULTIPLIER;
	    };
	} else for (i=0;i<SOUND_BUFFER_SIZE;i++) tmpwave[i]*=FMnewamplitude[nvoice]/(REALTYPE)OSCIL_SIZE*FM_AMP_MULTIPLIER;

    for (i=0;i<SOUND_BUFFER_SIZE;i++){
	//calculez frecventa carrier-ului

	
	FMmodfreqhi=(int) floor(tmpwave[i]);
	FMmodfreqlo=tmpwave[i]-floor(tmpwave[i]);

	//calculez carrier-ul
	carposhi=oscposhi[nvoice]+FMmodfreqhi;
	carposlo=oscposlo[nvoice]+FMmodfreqlo;

	if (carposlo>=1.0) {
	    carposhi++;
	    carposlo-=1.0;
	};
	
	carposhi&=(OSCIL_SIZE-1);	
	oscposhi2=(carposhi+1)&(OSCIL_SIZE-1);
	
	tmpwave[i]=NoteVoicePar[nvoice].OscilSmp[carposhi]*(1.0-carposlo)+NoteVoicePar[nvoice].OscilSmp[oscposhi2]*carposlo;

	oscposlo[nvoice]+=oscfreqlo[nvoice];
	if (oscposlo[nvoice]>=1.0) {
    		oscposlo[nvoice]-=1.0;	
		oscposhi[nvoice]++;
	};

    	oscposhi[nvoice]+=oscfreqhi[nvoice];    
	oscposhi[nvoice]&=OSCIL_SIZE-1;

    };
};


int ADnote::noteout(REALTYPE *out){
//intoarce 0 daca nu mai are rost sa se apeleze;
  int i,nvoice;

  for (i=0;i<SOUND_BUFFER_SIZE;i++) out[i]=0;

  if (NoteEnabled==OFF) return(0);
  
  computecurrentparameters();    

  for (nvoice=0;nvoice<NUM_VOICES;nvoice++){
	if (NoteVoicePar[nvoice].Enabled!=ON) continue;
	switch (NoteVoicePar[nvoice].FMEnabled){
	    case RING_MOD:ComputeVoiceOscillatorRingModulation(nvoice);break;
	    case FREQ_MOD:ComputeVoiceOscillatorFM(nvoice);break;
	    default:ComputeVoiceOscillator(nvoice);
	    };
    //aici proceses vocea (filtre,si alte kestii)
    
     //Amplitude
     if (2.0*fabs(newamplitude[nvoice]-oldamplitude[nvoice])/(newamplitude[nvoice]+oldamplitude[nvoice]+0.00000001)>AMPLITUDE_INTERPOLATION_THRESHOLD){
    	  //interpoleaza amplitudinea
          for (i=0;i<SOUND_BUFFER_SIZE;i++){
		tmpwave[i]*=oldamplitude[nvoice]+(newamplitude[nvoice]-oldamplitude[nvoice])*(REALTYPE)i/(REALTYPE)SOUND_BUFFER_SIZE;
	    };
	} else for (i=0;i<SOUND_BUFFER_SIZE;i++) tmpwave[i]*=newamplitude[nvoice];
     //Filtrul    
     if (NoteVoicePar[nvoice].FilterEnabled==ON) NoteVoicePar[nvoice].VoiceFilter->filterout(&tmpwave[0]);



     //adun la "out"
      for (i=0;i<SOUND_BUFFER_SIZE;i++) out[i]+=tmpwave[i];
    //ultima data verific daca mai merita sa mai procesez oscilul (daca nu s-a terminat "amplitude envelope")
      if (NoteVoicePar[nvoice].AmpEnvelopeEnabled==ON) {
    	 if (NoteVoicePar[nvoice].AmpEnvelope->finished()!=0) KillVoice(nvoice);
	 };
      };

    //aici proceses parametrii NoteGlobalPar.i
  if (2.0*fabs(globalnewamplitude-globaloldamplitude)/(globalnewamplitude+globaloldamplitude+0.00000001)>AMPLITUDE_INTERPOLATION_THRESHOLD){
    //interpoleaza amplitudinea
      for (i=0;i<SOUND_BUFFER_SIZE;i++){
	out[i]*=globaloldamplitude+(globalnewamplitude-globaloldamplitude)*(REALTYPE)i/(REALTYPE)SOUND_BUFFER_SIZE;
      };
  } else for (i=0;i<SOUND_BUFFER_SIZE;i++) out[i]*=globalnewamplitude;
      
     NoteGlobalPar.GlobalFilter->filterout(&out[0]); 
     
 //verific daca s-a terminat envelop-ul global. Daca da, atunci dezactivez nota     
 if (NoteGlobalPar.AmpEnvelope->finished()!=0) KillNote(); //ar trebui sa fac un fadeout!!!!!!!!!
 return(1);
};


void ADnote::relasekey(){
int nvoice;
  for (nvoice=0;nvoice<NUM_VOICES;nvoice++){
    if (NoteVoicePar[nvoice].AmpEnvelopeEnabled==ON) NoteVoicePar[nvoice].AmpEnvelope->relasekey(); 
    if (NoteVoicePar[nvoice].FreqEnvelopeEnabled==ON) NoteVoicePar[nvoice].FreqEnvelope->relasekey(); 
    if (NoteVoicePar[nvoice].FilterEnvelopeEnabled==ON) NoteVoicePar[nvoice].FilterEnvelope->relasekey(); 
    if (NoteVoicePar[nvoice].FMFreqEnvelopeEnabled==ON) NoteVoicePar[nvoice].FMFreqEnvelope->relasekey(); 
    if (NoteVoicePar[nvoice].FMAmpEnvelopeEnabled==ON) NoteVoicePar[nvoice].FMAmpEnvelope->relasekey(); 
    NoteGlobalPar.FreqEnvelope->relasekey();
    NoteGlobalPar.FilterEnvelope->relasekey();
    NoteGlobalPar.AmpEnvelope->relasekey();
  };

};

int ADnote::finished(){
    if (NoteEnabled==ON) return(0);
	else return(1);
};

