#include <stdio.h>
#include "Envelope.h"

Envelope::Envelope(EnvelopeParams *envpars){
    int i;
    envpoints=envpars->Penvpoints;
    if (envpoints>MAX_ENVELOPE_POINTS) envpoints=MAX_ENVELOPE_POINTS;
    envsustain=envpars->Penvsustain;
    envstretch=1.0;//trebuie modificat

    for (i=0;i<MAX_ENVELOPE_POINTS;i++) {//nu ar trebui sa copieze chiar toate env...[]
	envdt[i]=envpars->envdt[i];
	envval[i]=envpars->envval[i];
	};
    //valorile interne
    currentpoint=1;//incep de la 1
    keyrelased=0;
    t=0;
    envfinish=0;
};

Envelope::~Envelope(){
};


void Envelope::relasekey(){
    keyrelased=1;
};

REALTYPE Envelope::envout(){
    REALTYPE out;

    if (envfinish!=0) return(envval[envpoints-1]);
    if ((currentpoint==envsustain+1)&&(keyrelased==0)) return(envval[envsustain]);
    
    if (envdt[currentpoint]*1000.0<INCT) out=envval[currentpoint];
	else out=envval[currentpoint-1]+
	    (envval[currentpoint]-envval[currentpoint-1])/envdt[currentpoint]*t;
    t+=INCT;

    if (t>envdt[currentpoint]){
	if (currentpoint>=envpoints-1) envfinish=1;
	    else  currentpoint++;
	t=0;//aici pot sa schimb cu t-=envdt[currentpoint] pana cand este corect
    };
    
    
    return (out);
};

REALTYPE Envelope::envout_dB(){
    REALTYPE tmp,val0;
    //primul punct este interpolat liniar(necesar pentru attack), restul este logaritmic
    if (currentpoint!=1) return(dB2rap(envout()));
	else {
	    tmp=envval[1]-envval[0];
	    if (fabs(tmp)<0.00000001) return(dB2rap(envout()));
	    val0=dB2rap(envval[0]);
	    tmp=val0+(dB2rap(envval[1])-val0)*((envout()-envval[0])/tmp);
	    return(tmp);
	    };
};

int Envelope::finished(){
    return(envfinish);
};

