#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>

#include <unistd.h>
#include <pthread.h>

#include "Synth/ADnote.h"
#include "Output/OSSaudiooutput.h"
#include "Midi/MidiParser.h"

#include "DSP/Reverb.h"

ADnote *notes[127];
ADnoteParameters *testpar;
OSSaudiooutput *audioout;
Reverb *rev;

void *thread1(void *arg){
    MidiCmdType cmdtype;
    unsigned char cmdchan,note,vel;
    unsigned char cmdparams[MP_MAX_BYTES];
    MidiParser *Midi=new MidiParser();
    
    while (1){
	Midi->getmidicmd(cmdtype,cmdchan,cmdparams);
        note=cmdparams[0];
	vel=cmdparams[1];
	fprintf(stderr,"__%d __%d \n",note,vel);
	if (vel!=0)if (notes[note]==NULL) {
	    notes[note]=new ADnote (testpar,note,vel/127.0);
	    printf("NoteOn\n");
	    };
	if (vel==0) if (notes[note]!=NULL) notes[note]->relasekey();
    };
};

void *thread2(void *arg){
    int i,x;
    REALTYPE xx;
    REALTYPE smps[SOUND_BUFFER_SIZE];
    REALTYPE output[SOUND_BUFFER_SIZE];

    while (1){
    	    for (i=0;i<SOUND_BUFFER_SIZE;i++) output[i]=0.0;
    
	for (i=0;i<127;i++)
	    if (notes[i]!=NULL) {
		notes[i]->noteout(&smps[0]);
		for (x=0;x<SOUND_BUFFER_SIZE;x++) output[x]+=smps[x]/20.0;//reduce volume
		if (notes[i]->finished()!=0) {
			delete(notes[i]);
			notes[i]=NULL;
		    };
		};
	    rev->revout(SOUND_BUFFER_SIZE,output,NULL);
	    audioout->OSSout(output,output);
    	    /*for (i=0;i<SOUND_BUFFER_SIZE;i++){
		xx=-output[i]/NUM_VOICES*32768/4;
		if (xx<-32768) xx=-32768;
		if (xx>32767) xx=32767;
		x=(short int) xx;
		fwrite(&x,2,1,stdout);
		fwrite(&x,2,1,stdout);//pt. esdcat
		};*/
	};
};


main(){
    pthread_t thr1,thr2;
    int i;
    
    srand(time(NULL));
    testpar=new ADnoteParameters ();
    
    audioout=new OSSaudiooutput();
    rev = new Reverb();    
    
    for (i=0;i<127;i++){
	notes[i]=NULL;
    };

    pthread_create(&thr1,NULL,thread1,NULL);
    pthread_create(&thr2,NULL,thread2,NULL);
        
//    notes[1]=new ADnote (testpar,54,127.0);//////////////////////////////////////////////

    while (1){ 
	sleep(300);
    };    
//    testnote->relasekey();
//    fprintf(stderr,"%d ",pid);
    


    delete(audioout);
    
};



